# Roo Code 3.12 Release Notes (2025-04-16)

This release introduces xAI provider support, improves diff editing, enhances UI with search capabilities, adds OpenAI model support, and includes various usability improvements and bug fixes.

## Provider Updates

*   Added [xAI provider](/providers/xai) and exposed reasoning effort options for Grok on OpenRouter. (thanks Cline!)
*   Added support for OpenAI `o3` & `4o-mini` models. (thanks PeterDaveHello!)

## Profile-Specific Diff Settings

*   **Profile-Specific Settings**: Diff editing configuration now works on a per-profile basis, giving you greater control over how code edits work with different providers. Learn more about [API Configuration Profiles](/features/api-configuration-profiles).

### How It Works

* **Multiple Profile Support**: Each profile stores its own diff editing preferences
* **Flexible Configuration**: Switch between profiles to instantly change how diffs are handled
* **Provider-Specific Control**: Use different diff strategies for different code providers
* **Isolated Settings**: Changes in one profile don't affect others

For example, you can create a profile for one provider with strict whitespace handling, and another profile with more relaxed rules. When you switch profiles, the system automatically applies the appropriate diff editing configuration.

## Keyboard Shortcuts

### Keyboard Shortcuts for Input Acceptance

Added the `roo.acceptInput` command to allow users to accept input or suggestions using keyboard shortcuts instead of mouse clicks. (thanks axkirillov!) This feature:

#### Key Benefits

* **Keyboard-Driven Interface**: Submit text or select the primary suggestion button without mouse interaction
* **Improved Accessibility**: Essential for users with mobility limitations or those who experience discomfort with mouse usage
* **Vim/Neovim Compatibility**: Supports transitions for developers coming from keyboard-centric environments
* **Workflow Efficiency**: Reduces context switching between keyboard and mouse during development tasks

For detailed setup and usage instructions, see our new [Keyboard Shortcuts](/features/keyboard-shortcuts) documentation page.


## QOL Improvements

*   Improved pre-diff string normalization for better editing reliability, especially with whitespace-sensitive languages.
*   Made checkpoints faster and more reliable for smoother project state management.
*   Added a search bar to mode and profile select dropdowns for easier navigation. (thanks samhvw8!)
*   Improved file/folder context mention UI for better usability. (thanks elianiva!)
*   Added telemetry for code action usage, prompt enhancement usage, and consecutive mistake errors to improve product stability.
*   Enhanced diff error telemetry for better troubleshooting capabilities.
*   Suppressed zero cost values in the task header for cleaner UI. (thanks do-it!)

## Bug Fixes

*   Fixed a bug affecting the Edit button visibility in the select dropdowns.
*   Made JSON parsing safer to avoid crashing the webview on bad input.